package us.lakora.bombdrop;

import java.awt.BorderLayout;
import java.awt.Dimension;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.net.URL;

import javax.swing.BorderFactory;
import javax.swing.BoxLayout;
import javax.swing.ImageIcon;
import javax.swing.JButton;
import javax.swing.JDialog;
import javax.swing.JLabel;
import javax.swing.JPanel;

public class HelpDialog extends JDialog implements ActionListener {
	private static final long serialVersionUID = 1L;

//	public static void main(String[] args) {
//		JDialog jd = new HelpDialog();
//		jd.setVisible(true);
//	}
	
	public HelpDialog() {
		setDefaultCloseOperation(JDialog.DISPOSE_ON_CLOSE);
		this.setModalityType(JDialog.DEFAULT_MODALITY_TYPE);
		setTitle(BombdropMenu.TITLE + " - Help");
		setLayout(new BoxLayout(getContentPane(), BoxLayout.PAGE_AXIS));
		ImageIcon[] icons = new ImageIcon[3];
		for (int i=0; i<icons.length; i++) {
			URL iconURL = MainWindow.class.getClassLoader().getResource("resources/docs" + (i+1) + ".png");
			if (iconURL != null) {
				icons[i] = new ImageIcon(iconURL);
			} else {
				icons[i] = new ImageIcon(); // failsafe - not sure if this is necessary
			}
		}
		JLabel docs1 = new JLabel(icons[0]);
		JLabel docs2 = new JLabel(icons[1]);
		JLabel docs3 = new JLabel(icons[2]);
		// Adding HTML tags causes JLabel to wrap the text.
		JLabel text1 = new JLabel("<html>Groups of two, three, or four blocks fall from the top of the playing field, one at a time. " +
				"You can control their movement with the arrow keys and rotate them left and right with Z and X.</html>");
		JLabel text2 = new JLabel("<html>Yellow blocks are bombs. When a line is filled, the bombs in that line will explode. " +
				"The explosion is higher when more lines are filled at the same time.</html>");
		JLabel text3 = new JLabel("<html>When four yellow bombs make a square, they become big bombs (orange). These big bombs together will " +
				"always create a 10x8 explosion. Put them in the middle and the explosion will cover the whole width of the field.</html>");
		JLabel text4 = new JLabel("<html>When playing in level mode, clearing the screen completely of " +
				"blocks will take you to the next level.</html>");
		docs1.setBorder(BorderFactory.createEmptyBorder(8, 16, 8, 00));
		docs2.setBorder(BorderFactory.createEmptyBorder(8, 00, 8, 16));
		docs3.setBorder(BorderFactory.createEmptyBorder(8, 16, 8, 00));
		text1.setBorder(BorderFactory.createEmptyBorder(8, 16, 8, 16));
		text2.setBorder(BorderFactory.createEmptyBorder(8, 16, 8, 16));
		text3.setBorder(BorderFactory.createEmptyBorder(8, 16, 8, 16));
		text4.setBorder(BorderFactory.createEmptyBorder(8, 16, 8, 16));
		JPanel p1 = new JPanel();
		p1.setLayout(new BorderLayout());
		p1.add(docs1, BorderLayout.WEST);
		p1.add(text1, BorderLayout.CENTER);
		add(p1);
		JPanel p2 = new JPanel();
		p2.setLayout(new BorderLayout());
		p2.add(text2, BorderLayout.CENTER);
		p2.add(docs2, BorderLayout.EAST);
		add(p2);
		JPanel p3 = new JPanel();
		p3.setLayout(new BorderLayout());
		p3.add(docs3, BorderLayout.WEST);
		// Adding HTML tags causes JLabel to wrap the text.
		p3.add(text3, BorderLayout.CENTER);
		add(p3);
		JPanel p4 = new JPanel();
		p4.setLayout(new BorderLayout());
		p4.add(text4);
		add(p4);
		JPanel p5 = new JPanel();
		p5.setLayout(new BoxLayout(p5, BoxLayout.LINE_AXIS));
		JButton close = new JButton("Close");
		p5.add(close, BorderLayout.SOUTH);
		p5.setBorder(BorderFactory.createEmptyBorder(00, 8, 16, 8));
		close.addActionListener(this);
		add(p5);
		setSize(new Dimension(450, 640));
	}

	@Override
	public void actionPerformed(ActionEvent e) {
		this.setVisible(false);
		this.dispose();
	}

}
