package us.lakora.bombdrop;

import java.awt.Color;
import java.awt.Font;
import java.awt.Graphics;

import javax.swing.JPanel;

public class PreviewPanel extends JPanel {
	private static final long serialVersionUID = 1L;
	private BlockGroup next;

//	public static void main(String[] args) {
//		
//		JFrame f = new JFrame();
//		PreviewPanel p = new PreviewPanel();
//		f.setContentPane(p);
//		f.pack();
//		f.setVisible(true);
//		try {
//			Thread.sleep(1000);
//		} catch (InterruptedException e) {
//			// TODO Auto-generated catch block
//			e.printStackTrace();
//		}
//
//		p.setNext(new BlockGroup(8));
//	}
	
	public PreviewPanel() {
	}
	
	public void setNext(BlockGroup next) {
		this.next = next;
		repaint();
	}
	
	public void paintComponent(Graphics g) {
		g.setColor(Color.black);
		g.fillRect(0, 0, this.getWidth(), this.getHeight());
		if (next != null) {
			int buffer = 8;
			int width = this.getWidth() - 2*buffer;
			int height = this.getHeight() - 2*buffer;
			width = width - width % 4;
			height = height - height % 4;
			g.setColor(Color.white);
			g.setFont(new Font("DejaVu Sans", Font.BOLD, 12));
			g.drawString("NEXT", 12, 12);
			int xbuffer = 0, ybuffer = 16;
			if (width > height) {
				xbuffer += (width - height) / 2;
				ybuffer += 0;
				width = height;
			} else {
				ybuffer += (height - width) / 2;
				xbuffer += 0;
				height = width;
			}
			Color[][] blocks = next.getBlocks();
			if (blocks.length == 2) { // for 2x2 - makes the preview smaller
				Color[][] preview = {
						new Color[4],
						{null, blocks[0][0], blocks[0][1], null},
						{null, blocks[1][0], blocks[1][1], null},
						new Color[4]
				};
				blocks = preview;
			}
			// paint blocks now
			for (int x=0; x<blocks.length; x++) for (int y=0; y<blocks[x].length; y++) {
				if (blocks[y][x] != null) {
					g.setColor(blocks[y][x]);
					g.fillRect(xbuffer+buffer+(int)(x*width/(double)blocks.length),
							ybuffer+buffer+(int)(y*height/(double)blocks.length),
							(int)(width/(double)blocks.length),
							(int)(height/(double)blocks.length));
					g.setColor(blocks[y][x].darker());
					g.drawRect(xbuffer+buffer+(int)(x*width/(double)blocks.length),
							ybuffer+buffer+(int)(y*height/(double)blocks.length),
							(int)(width/(double)blocks.length),
							(int)(height/(double)blocks.length));
				}
			}
		}
	}

}
