package us.lakora.bombdrop;

import java.awt.GridLayout;

import javax.swing.JLabel;
import javax.swing.JPanel;

public class Score extends JPanel {
	private static final long serialVersionUID = 1L;
	
	/**
	 * Taken from the Game Boy version of Tetris.
	 */
	public static final int[] DELAYS = {
		53,49,45,41,37,
		33,28,22,17,11,
		10,9,8,7,6,
		6,6,5,5,4,3};
	
	private int lines;
	private int score;
	private int drops;
	private JLabel linesL;
	private JLabel scoreL;
	private boolean showDrops;
	
	public Score() {
		linesL = new JLabel();
		scoreL = new JLabel();
		super.setLayout(new GridLayout(2, 1));
		super.add(linesL);
		super.add(scoreL);
		reset();
	}
	
	public synchronized int addLines(int add) {
		this.lines += add;
		if (add == 1) {
			score += 40*(lines/10 + 1);
		} else if (add == 2) {
			score += 100*(lines/10 + 1);
		} else if (add == 3) {
			score += 300*(lines/10 + 1);
		} else if (add == 4) {
			score += 1200*(lines/10 + 1);
		}
		updateLabel();
		return lines;
	}
	
	public void updateLabel() {
		linesL.setText("Lines: " + lines);
		if (showDrops) {
			scoreL.setText("Drops: " + drops);
		} else {
			scoreL.setText("Score: " + score);
		}
		repaint();
	}
	
	public int getLevel() {
		if (lines/10 < (DELAYS.length - 1)) {
			return lines/10;
		} else {
			return DELAYS.length - 1;
		}
	}
	
	public synchronized void reset() {
		lines = 0;
		score = 0;
		drops = 0;
		updateLabel();
	}

	public void addScore(int i) {
		score += i;
		updateLabel();
	}
	
	public void addDrop() {
		drops++;
		updateLabel();
	}
	
	public void displayDrops(boolean b) {
		this.showDrops = b;
		updateLabel();
	}

}
