package us.lakora.bombdrop.bombs;

import java.awt.Color;

/**
 * A 2x2 bomb. Used only when finding what squares should cause an explosion - during gameplay, bombs are defined by their color on the board.
 *
 * @version  1.0
 * @author   Isaac Schemm, isaacschemm@gmail.com
 */

public class BigBomb extends Bomb {
	
	// Does not auto-adjust. Used in activateBombs.
	public BigBomb(int x, int y) {
		super(x, y);
	}
	
	// This constructor auto-adjusts to the top-left corner
	public BigBomb(int x, int y, Color[][] matrix) {
		super(x, y);
		Color c = matrix[y][x];
		if (c.equals(matrix[y-1][x])) { // Square above is same color
			if (c.equals(matrix[y-1][x-1])) { // Square above and to the left is same color
				super.setLocation(x-1, y-1);
			} else {
				super.setLocation(x, y-1);
			}
		} else {
			if (c.equals(matrix[y][x-1])) { // Square to the left is same color
				super.setLocation(x-1, y);
			}
		}
		
	}
	
	public boolean equals(Object o) {
		boolean same = false;
		if (this == o) {
			same = true;
		} else {
			if (o instanceof BigBomb) {
				same = super.equals(o);
			} else {
				same = false;
			}
		}
		return same;
	}

}
