package us.lakora.bombdrop.bombs;

/**
 * An abstract class for things that explode.
 * @see SmallBomb
 * @see BigBomb
 *
 * @version  1.0
 * @author   Isaac Schemm, isaacschemm@gmail.com
 */

public abstract class Bomb {
	
	private int x;
	private int y;
	
	public Bomb(int x, int y) {
		this.x = x;
		this.y = y;
	}

	public int getX() {
		return x;
	}
	public int getY(){
		return y;
	}
	
	/**
	 * A workaround for BigBomb's constructor that takes a matrix.
	 * @param x
	 * @param y
	 */
	protected void setLocation(int x, int y) {
		this.x = x;
		this.y = y;
	}
	
	public String toString() {
		return x + ", " + y;
	}
	
	public boolean equals(Object o) { // Will only be called by subclasses
		Bomb b = (Bomb)o;
		return ((this.x == b.x) && (this.y == b.y));
	}

}
